#
# USAGE:
#
# 1. client side
#
#   Azuma::DRb.start(['小栗虫太郎', '夢野久作', '塔晶夫'])
#   > "druby://localhost:8989'
#
# 2. server side
#
#   roulette = DRb::DRbObject.new_with_uri('druby://localhost:8989')
#   roulette.next_talker
#
require 'drb'

module Azuma
  class DRb
    def self.start(talkers)
      roulette = Azuma.entry(talkers)

      @server = ::DRb.start_service(nil, roulette)

      puts "drb starting on #{::DRb.uri}"

      Signal.trap(:INT) do
        puts; puts('Stopping ...')

        @server.stop_service

        puts('Exiting ...'); exit!
      end

      ::DRb.uri
    end
  end
end
